#region
/* Adoor.NET - Object/Relational mapping framework leveraging ADO.NET`s powerful disconnected mode.
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *  
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *  
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */ 
#endregion

using System;
using Adoor.Object.Entity;
using Adoor.Object.Query;

namespace Adoor.Object.Disconnected
{
	/// <summary>
	/// Flags indicating what to load.
	/// </summary>
	[Flags] public enum PreloadFlags { None = 0, Reference = 1, TargetEntities = 2 }

	/// <summary>
	/// Interface supported by mappers to load entities to <see cref="ObjectContext"/> objects.
	/// </summary>
	public interface IEntityLoader
	{
		void Load(ObjectContext context, string correlation, ObjectPath path, object args);
		void Load(ObjectContext context, string oid);
		void CompleteReference(IObjectStorage localStore, string oid, string roleName, PreloadFlags flags);
	}
}