#region
/* Adoor.NET - Object/Relational mapping framework leveraging ADO.NET`s powerful disconnected mode.
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *  
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *  
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */ 
#endregion

namespace Adoor.Object.Disconnected
{
	/// <summary>
	/// Interface supported by mappers to update entities and references from <see cref="ObjectContext"/> objects.
	/// </summary>
	public interface IEntityUpdater
	{
        void UpdateDeletedEntities(ObjectContext context);
        void UpdateInsertEntities(ObjectContext context);
        void UpdateUpdatedEntities(ObjectContext context);
        //void UpdateEntities(ObjectContext context);
		void UpdateRelations(ObjectContext context);
		//void Commit(ObjectContext context);
	}	
}