#region
/* Adoor.NET - Object/Relational mapping framework leveraging ADO.NET`s powerful disconnected mode.
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *  
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *  
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */ 
#endregion

using System.ComponentModel;
//using Adoor.Object.Design;

namespace Adoor.Object.Disconnected
{
	/// <summary>
	/// Structure representing a remote resource.
	/// </summary>
	/// <remarks>Essentially use for design-time purposes.</remarks>
	//[TypeConverter(typeof(RemoteSourceConverter))]
    [System.Obsolete("use LinkedDomainGroup and attached RelationalSource instead",true)]
	public struct RemoteSource
	{
		private IObjectSource objectSource;

		public RemoteSource(IObjectSource objectSource)
		{
			this.objectSource = objectSource;
		}

		public IObjectSource ObjectSource
		{
			get { return this.objectSource; }
			set { this.objectSource = value; }
		}

		public override string ToString()
		{
			if (this.objectSource != null)
				return this.objectSource.ToString();
			else
				return base.ToString();
		}
	}
}