using System;
using System.Collections.Generic;
using System.Text;
using Adoor.Object.Domain;
using Adoor.Object.Query;
using Adoor.Object.Entity;

namespace Adoor.Object.Domain
{
    /// <summary>
    /// Object implmenting this interface allow various lookup on Domain
    /// </summary>
    public interface IObjectResolver
    {
        ICollection<ObjectDomain> ManagedDomains { get; }
        Type GetType(object entity);
        EntityData FindEntityData(Type type);
        EntityData FindEntityData(string name);
        IEntityFactory FindFactory(Type type);
        ObjectPath GetPath(Type type);
        ObjectPath GetPath(Type type, string alias);
        ObjectPath GetPath(string name);
        ObjectPath GetPath(string name, string alias);
        ObjectQuery ParseQuery(string text);
        ObjectPath ParsePath(string text);
    }
}
