#region
/* Adoor.NET - Object/Relational mapping framework leveraging ADO.NET`s powerful disconnected mode.
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *  
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *  
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */ 
#endregion

using System;
using Adoor.Object.Domain;

namespace Adoor.Object.Entity
{
	/// <summary>
	/// An interface supported by mappers capable to manage the lifecyle of an entity.
	/// </summary>
	public interface IEntityFactory 
	{
		EntityData EntityData { get; }
		Type ImplementationType { get; }

		/* storable aspect */
		IEntity Find(IObjectStorage localStore, string oid);
		object Create(IObjectStorage localStore, params object[] args);
		void Validate(IObjectStorage localStore, Adoor.Object.Disconnected.ObjectContext context);
		void Clear(IObjectStorage localStore);
        void Cancel(IObjectStorage localStore);
	}
}