#region
/* Adoor.NET - Object/Relational mapping framework leveraging ADO.NET`s powerful disconnected mode.
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *  
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *  
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */ 
#endregion

using System.Collections.Generic;
using Adoor.Object.Domain;

namespace Adoor.Object.Entity
{
    public interface IOidFactory
    {
        IOidData OidData { get; }
        // A value, generally based on EntityData.ClassId, used to discriminate this oid in a polymorphic context
        object Discriminator { get; } // TODO: move to IOidDiscriminator.Discriminator
        void CreateKey(IEntityState state);
    }

	/// <summary>
	/// An interface supported by OID mappers for the management of the lifecycle of OIDs.
	/// </summary>
	public interface IOidFactory<TEntity> : IOidFactory
	{
		
	}
}