#region
/* Adoor.NET - Object/Relational mapping framework leveraging ADO.NET`s powerful disconnected mode.
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *  
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *  
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */ 
#endregion

using System;
using System.Data.SqlTypes;
using Adoor.Object.Domain;

namespace Adoor.Object.Entity
{
	/// <summary>
	/// An interface supported by property mappers for the reading of property values.
	/// </summary>
	public interface IPropertyReader
	{	
		PropertyData PropertyData { get; }
		object GetObject(IEntity sourceEntity);
		String GetString(IEntity sourceEntity);
		SqlString GetSqlString(IEntity sourceEntity);
		Boolean GetBoolean(IEntity sourceEntity);
		SqlBoolean GetSqlBoolean(IEntity sourceEntity);
		Int32 GetInt32(IEntity sourceEntity);
		SqlInt32 GetSqlInt32(IEntity sourceEntity);
		Int16 GetInt16(IEntity sourceEntity);
		SqlInt16 GetSqlInt16(IEntity sourceEntity);
		Double GetDouble(IEntity sourceEntity);
		SqlDouble GetSqlDouble(IEntity sourceEntity);
		Single GetSingle(IEntity sourceEntity);
		SqlSingle GetSqlSingle(IEntity sourceEntity);
		DateTime GetDateTime(IEntity sourceEntity);
		SqlDateTime GetSqlDateTime(IEntity sourceEntity);
		Decimal GetDecimal(IEntity sourceEntity);
		SqlDecimal GetSqlDecimal(IEntity sourceEntity);
		Byte[] GetByteArray(IEntity sourceEntity);
		Guid GetGuid(IEntity sourceEntity);
		SqlGuid GetSqlGuid(IEntity sourceEntity);
	}
}
