#region
/* Adoor.NET - Object/Relational mapping framework leveraging ADO.NET`s powerful disconnected mode.
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *  
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *  
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */ 
#endregion

using System.Collections.Generic;
using System.Data;

namespace Adoor.Relational.SqlDriver
{
	public interface ISqlDriver
	{
		string[] SelectCommand(RelationalQuery query);
		string CountCommand(RelationalQuery query);
		string DeleteCommand(RelationalQuery query);
		string UpdateCommand(RelationalQuery query);
		string[] NonQueryCommand(RelationalQuery query);

		string GetSelectCommand(DataTable table, ICollection<DataColumn> dataColumns);
        string GetUpdateCommand(DataTable table, bool updateWhereAll, bool refreshDataFromDatabase, ICollection<DataColumn> dataColumns, LockMode lockMode);
        string GetInsertCommand(DataTable table, bool refreshDataFromDatabase, ICollection<DataColumn> dataColumns, LockMode lockMode);
		string GetDeleteCommand(DataTable table, bool updateWhereAll, ICollection<DataColumn> dataColumns, LockMode lockMode);
		string DefaultSelectIsolationLevelQuery { get; }
	}

	public enum LockMode
	{
		Default,
		NoLock,
		RowLock
	}
}
