using System;
using System.Text;
using System.Windows.Forms;
using System.Xml;
using System.IO;

namespace Adoor.Metadata
{
	public class XmlRichTextBoxWriter: XmlWriterDecorator
	{
		RichTextBox rtbResult;
		StringBuilder sb = new StringBuilder();

		public RichTextBox RichTextBox
		{
			get{ return rtbResult; }
		}

		public XmlRichTextBoxWriter(RichTextBox rtbResult)
			: base(null)
		{
			this.rtbResult = rtbResult;
			XmlTextWriter xmlTextWriter = new XmlTextWriter(new StringWriter(this.sb));
			xmlTextWriter.Formatting = Formatting.Indented;
			xmlTextWriter.Indentation = 8;
			this.Principal = xmlTextWriter;
		}

		public override void Flush()
		{
			base.Flush();

            this.rtbResult.Invoke(new textDelegate(delegate(string txt)
            {
                this.rtbResult.Text += txt;
            }), sb.ToString());
		}

        private delegate void textDelegate(string txt);

		public override void Close()
		{
			Flush();
			base.Close();
		}
	}
}
