using System;
using System.Xml;

namespace Adoor.Metadata
{
	public class XmlWriterDecorator : XmlWriter
	{
		private XmlWriter principal;
		public virtual XmlWriter Principal
		{
			get { return this.principal; }
			set { this.principal = value; }
		}

		public XmlWriterDecorator(XmlWriter principal)
		{
			this.principal = principal;
		}

		public override void Close()
		{
			this.Principal.Close();	
		}

		public override void Flush()
		{
			this.Principal.Flush();
		}

		public override string LookupPrefix(string ns)
		{
			return this.Principal.LookupPrefix(ns);
		}

		public override void WriteBase64(byte[] buffer, int index, int count)
		{
			this.Principal.WriteBase64(buffer, index, count);
		}

		public override void WriteBinHex(byte[] buffer, int index, int count)
		{
			this.Principal.WriteBinHex(buffer, index, count);
		}

		public override void WriteCData(string text)
		{
			this.Principal.WriteCData(text);
		}

		public override void WriteCharEntity(char ch)
		{
			this.Principal.WriteCharEntity(ch);
		}

		public override void WriteChars(char[] buffer, int index, int count)
		{
			this.Principal.WriteChars(buffer, index, count);
		}

		public override void WriteComment(string text)
		{
			this.Principal.WriteComment(text);
		}

		public override void WriteDocType(string name, string pubid, string sysid, string subset)
		{
			this.Principal.WriteDocType(name, pubid, sysid, subset);			
		}

		public override void WriteEndAttribute()
		{
			this.Principal.WriteEndAttribute();
		}

		public override void WriteEndDocument()
		{
			this.Principal.WriteEndDocument();
		}		

		public override void WriteEntityRef(string name)
		{
			this.Principal.WriteEntityRef(name);
		}

		public override void WriteFullEndElement()
		{
			this.Principal.WriteFullEndElement();
		}

		public override void WriteName(string name)
		{
			this.Principal.WriteName(name);
		}
		public override void WriteNode(XmlReader reader, bool defattr)
		{
			base.WriteNode (reader, defattr);
		}


		public override void WriteNmToken(string name)
		{
			this.Principal.WriteNmToken(name);
		}

		public override void WriteProcessingInstruction(string name, string text)
		{
			this.Principal.WriteProcessingInstruction(name, text);
		}

		public override void WriteQualifiedName(string localName, string ns)
		{
			this.Principal.WriteQualifiedName(localName, ns);
		}

		public override void WriteRaw(char[] buffer, int index, int count)
		{
			this.Principal.WriteRaw(buffer, index, count);
		}

		public override void WriteRaw(string data)
		{
			this.Principal.WriteRaw(data);
		}

		public override void WriteStartAttribute(string prefix, string localName, string ns)
		{
			this.Principal.WriteStartAttribute(prefix, localName, ns);
		}

		public override void WriteStartDocument()
		{
			this.Principal.WriteStartDocument();
		}

		public override void WriteStartDocument(bool standalone)
		{
			this.Principal.WriteStartDocument(standalone);
		}

//		public void Log(string message, string level)
//		{
//			int iLevel = 0;
//			try
//			{
//				iLevel = int.Parse(level);
//			}
//			catch
//			{
//			}
//			OnLogMessage(message, iLevel);
//		}
//
//		protected virtual void OnLogMessage(string message, int level)
//		{
//			if(LogMessage != null)
//				LogMessage(this, new LogMessageEventArgs(message, level));
//		}
//
//		public event LogMessageEventHandler LogMessage;
//
//		public delegate void LogMessageEventHandler (object sender, LogMessageEventArgs e);
//
//		public class LogMessageEventArgs :EventArgs
//		{
//			public LogMessageEventArgs(string message, int level)
//			{
//				this._message = message;
//				this._level = level;
//			}
//
//			private string _message;
//
//			private int _level;
//
//			public string Message
//			{
//				get{ return _message;}
//			}
//
//			public int Level
//			{
//				get{ return _level; }
//			}
//
//		}

//		int inLog = 0;
//		System.Text.StringBuilder sbLog = new System.Text.StringBuilder();

		public override void WriteStartElement(string prefix, string localName, string ns)
		{
//			if(prefix == "log" && localName == "Log" && ns == "urn:log")
//			{
//				inLog++;
//			}
			this.Principal.WriteStartElement(prefix, localName, ns);
		}

		public override void WriteEndElement()
		{
//			if(inLog > 0)
//			{
//				inLog--;
//				if(inLog == 0)
//				{
//					sbLog.Length = 0;
//				}
//			}
			this.Principal.WriteEndElement();
		}

		public override WriteState WriteState
		{
			get
			{
				return this.Principal.WriteState;
			}
		}

		public override void WriteString(string text)
		{
			this.Principal.WriteString(text);
		}

		public override void WriteSurrogateCharEntity(char lowChar, char highChar)
		{
			this.Principal.WriteSurrogateCharEntity(lowChar, highChar);
		}

		public override void WriteWhitespace(string ws)
		{
			this.Principal.WriteWhitespace(ws);
		}


		public override string XmlLang
		{
			get
			{
				return this.Principal.XmlLang;
			}
		}

		public override XmlSpace XmlSpace
		{
			get
			{
				return this.Principal.XmlSpace;
			}
		}
	}
}
