CREATE USER MSPETSHOPORDERS IDENTIFIED BY password DEFAULT TABLESPACE USERS QUOTA UNLIMITED ON USERS; 

GRANT CREATE SESSION TO MSPETSHOPORDERS; 

create table MSPETSHOPORDERS.orders (
    orderid int not null,
    userid varchar(80) not null,
    orderdate date not null,
    shipaddr1 varchar(80) not null,
    shipaddr2 varchar(80) null,
    shipcity varchar(80) not null,
    shipstate varchar(80) not null,
    shipzip varchar(20) not null,
    shipcountry varchar(20) not null,
    billaddr1 varchar(80) not null,
    billaddr2 varchar(80)  null,
    billcity varchar(80) not null,
    billstate varchar(80) not null,
    billzip varchar(20) not null,
    billcountry varchar(20) not null,
    courier varchar(80) not null,
    totalprice number(10,2) not null,
    billtofirstname varchar(80) not null,
    billtolastname varchar(80) not null,
    shiptofirstname varchar(80) not null,
    shiptolastname varchar(80) not null,
    creditcard varchar(80) not null,
    exprdate char(7) not null,
    cardtype varchar(80) not null,
    locale varchar(20) not null,
    constraint PK_ORDERS primary key (orderid) );

create table MSPETSHOPORDERS.orderstatus (
    orderid int not null,
    linenum int not null,
    timestamp date not null,
    status char(2) not null,
    constraint PK_ORDERSTATUS primary key (orderid, linenum),
        constraint FK_ORDERSTATUS foreign key (orderid)
        references MSPETSHOPORDERS.ORDERS (orderid) );
        
create table MSPETSHOPORDERS.lineitem (
    orderid int not null,
    linenum int not null,
    itemid char(10) not null,
    quantity int not null,
    unitprice number(10,2) not null,
    constraint PK_LINEITEM primary key (orderid, linenum),
        constraint FK_LINEITEM foreign key (orderid)
        references MSPETSHOPORDERS.ORDERS (orderid) ) ;
        
CREATE SEQUENCE MSPETSHOPORDERS.ORDERNUM INCREMENT BY 1 START WITH 1 MAXVALUE 1.0E27 MINVALUE 1 NOCYCLE CACHE 10000 NOORDER;