//#define OleDb
//#define OptimisticKeyManager

using System;
using System.Collections;
using System.Reflection;
using Adoor.Relational;
using Adoor.Relational.RelationalSource;
using Adoor.Relational.SqlDriver;
using Adoor.Object;
using Adoor.Object.Disconnected;
using Adoor.Object.Relational;
using Adoor.DAL.Emprunts;
using Adoor.DAL.Ouvrages;
using NUnit.Framework;
using Adoor.Object.Domain;

namespace Biblio.NUnit
{
    public class BaseTest : Assertion
    {
        public static string ConnectionString;
        public static ObjectDomain OuvragesDomain;
        public static ObjectDomain EmpruntsDomain;

        static BaseTest()
        {
            //IDataSource datasource;
            //            Adoor.Data.SqlClient.FrmSqlConnection f = new Adoor.Data.SqlClient.FrmSqlConnection();
            //            f.Catalog = "Biblio";
            //            if (f.ShowDialog() == System.Windows.Forms.DialogResult.OK)  
            //            {
            //#if OleDb
            //                ConnectionString = "Provider=SQLOLEDB;Initial Catalog=" + f.Catalog + ";" + f.ConnectionString;
            //                datasource = new OleDbDataSource(ConnectionString);
            //#else
            //                ConnectionString = "Initial Catalog=" + f.Catalog + ";" + f.ConnectionString;
            //                datasource = new SqlDataSource(ConnectionString);
            //#endif
            //            }
            //            else
            //                throw new Exception("cannot connect to database");

            //            IDictionary extendedProperties = new Hashtable();
            //            extendedProperties["DataSource"] = datasource;
            //#if OptimisticKeyManager
            //#else
            //            extendedProperties["OidRange"] = 10;
            //#endif
            //            EmpruntsDomain = new ObjectDomain(Assembly.Load("Adoor.DAL.Emprunts"), "Adoor.DAL.Emprunts.Map.SqlServer.xml", extendedProperties);
        }

        public ObjectContext CreateContext()
        {
            //#if OleDb
            //            IDbRelationalSource source = new OleDbRelationalSource(ConnectionString, new TransactSqlDriver());
            //#else
            //            IDbRelationalSource source = new SqlRelationalSource(ConnectionString, new TransactSqlDriver());
            //#endif
            //            return new RelationalObjectContext(EmpruntsDomain, source);
            // Create context;
            ObjectContext ctxt = new ObjectContext();

            //Create and set the localStorage
            DataSetObjectStorage localStorage = new DataSetObjectStorage();
            ctxt.LocalStorage = localStorage;


            // Set a domain group
            LinkedDomainGroup domainGroup = new LinkedDomainGroup();

            // Connection
            System.Data.SqlClient.SqlConnectionStringBuilder csb = new System.Data.SqlClient.SqlConnectionStringBuilder();
            csb.ApplicationName = "Biblio";
            csb.AsynchronousProcessing = true;
            csb.DataSource = "www.titaye.net\\SQLEXPRESS,1434";
            csb.NetworkLibrary = "dbmssocn";
            //csb.Enlist = true;
            csb.InitialCatalog = "biblio";
            csb.Password = "dev";
            csb.UserID = "dev";

            RelationalObjectSource ros = new RelationalObjectSource();
            SqlRelationalSource source = new SqlRelationalSource(csb);
            ros.RelationalSource = source;
            domainGroup.RemoteSource = ros;

            // Add the different domains
            domainGroup.Add(typeof(Adoor.DAL.Emprunts.Adherent).Assembly, "Adoor.DAL.Emprunts.Mapping.xml");
            domainGroup.Add(typeof(Adoor.DAL.Ouvrages.Auteur).Assembly, "Adoor.DAL.Ouvrages.Mapping.xml");

            // Build the domains
            domainGroup.Build();
            ctxt.LinkedDomainCollection.Add(domainGroup);

            return ctxt;
        }

        public Bibliotheque CreateBibliotheque(ObjectContext context)
        {
            Bibliotheque bibliotheque = (Bibliotheque)context.LocalStorage.Create(typeof(Bibliotheque));
            bibliotheque.Nom = "Nom " + bibliotheque.ToString();
            return bibliotheque;
        }

        public Livre CreateLivre(ObjectContext context)
        {
            Livre livre = (Livre)context.LocalStorage.Create(typeof(Livre));
            livre.Nom = "Nom " + livre.ToString();
            livre.Prix = livre.GetHashCode();
            return livre;
        }

        public NumeroRevue CreateNumeroRevue(ObjectContext context)
        {
            NumeroRevue numeroRevue = (NumeroRevue)context.LocalStorage.Create(typeof(NumeroRevue));
            numeroRevue.Prix = numeroRevue.GetHashCode();
            return numeroRevue;
        }

        public Auteur CreateAuteur(ObjectContext context)
        {
            Auteur auteur = (Auteur)context.LocalStorage.Create(typeof(Auteur));
            auteur.Nom = "Nom " + auteur.ToString();
            auteur.Prenom = "Prnom " + auteur.ToString();
            return auteur;
        }

        public Categorie CreateCategorie(ObjectContext context)
        {
            Categorie categorie = (Categorie)context.LocalStorage.Create(typeof(Categorie));
            categorie.Libelle = "Libelle " + categorie.ToString();
            return categorie;
        }

        public Exemplaire CreateExemplaire(ObjectContext context)
        {
            Exemplaire exemplaire = (Exemplaire)context.LocalStorage.Create(typeof(Exemplaire));
            exemplaire.Numero = exemplaire.GetHashCode();
            return exemplaire;
        }

        public Emprunt CreateEmprunt(ObjectContext context)
        {
            Emprunt emprunt = (Emprunt)context.LocalStorage.Create(typeof(Emprunt));
            emprunt.Restitue = false;
            return emprunt;
        }

        //public Editeur CreateEditeur(ObjectContext context)
        //{
        //    Editeur editeur = (Editeur)context.LocalStorage.Create(typeof(Editeur));
        //    editeur.Nom = "Editeur " + editeur.ToString();
        //    return editeur;
        //}

        //public Test CreateTest(ObjectContext context)
        //{
        //    Test test = (Test)context.LocalStorage.Create(typeof(Test));
        //    return test;
        //}

    }
}
