#define OptimisticKeyManager
//#define OleDb
//#define Oracle

using System;
using System.Collections;
using System.Reflection;
using Adoor.Relational;
using Adoor.Relational.RelationalSource;
using Adoor.Relational.SqlDriver;
using Adoor.Data;
#if OleDb || Oracle
using Eldorado.Data.OleDb;
#else
//using Adoor.Data.SqlClient;
#endif
using Adoor.Object;
//using Adoor.Object.Relational;
using Adoor.Domain.Tiers;

using NUnit.Framework;

namespace Adoor.Nunit.Basic
{
    public class BaseTest : Assertion
    {
        public static System.Data.SqlClient.SqlConnectionStringBuilder ConnectionStringBuilder
        {
            get
            {
                System.Data.SqlClient.SqlConnectionStringBuilder csb = new System.Data.SqlClient.SqlConnectionStringBuilder();
                csb.ApplicationName = "Pension";
                csb.AsynchronousProcessing = true;
                csb.DataSource = "www.titaye.net\\SQLEXPRESS,1434";
                csb.NetworkLibrary = "dbmssocn";
                //csb.Enlist = true;
                csb.InitialCatalog = "SACI_RETRAITE";
                csb.Password = "dev";
                csb.UserID = "dev";
                return csb;
            }
        }

        static BaseTest()
        {

        }

        public Adoor.Object.Disconnected.ObjectContext CreateContext()
        {

            Adoor.Object.Disconnected.ObjectContext Context = new Adoor.Object.Disconnected.ObjectContext();
            Context.LocalStorage = new Adoor.Object.Relational.DataSetObjectStorage();

            //definition des domains
            Adoor.Object.Domain.LinkedDomainGroup group1 = new Adoor.Object.Domain.LinkedDomainGroup();

            Adoor.Object.Relational.RelationalObjectSource lObjectSource = new Adoor.Object.Relational.RelationalObjectSource();
            lObjectSource.RelationalSource = new SqlRelationalSource(ConnectionStringBuilder);
            group1.RemoteSource = lObjectSource;

            // Add the different domains
            string name = Assembly.GetExecutingAssembly().FullName;
            group1.Add(name, name, "Test.SqlServer.xml");

            group1.Build();
            Context.LinkedDomainCollection.Add(group1);

            return Context;

        }

        public Role_Assure CreateAssure(Adoor.Object.Disconnected.ObjectContext context)
        {
            Role_Assure result = (Role_Assure)context.LocalStorage.Create(typeof(Role_Assure));
            return result;
        }

        public Personne CreatePersonne(Adoor.Object.Disconnected.ObjectContext context)
        {
            Personne result = (Personne)context.LocalStorage.Create(typeof(Personne));
            return result;
        }

        public Coordonnee CreateCoordonnee(Adoor.Object.Disconnected.ObjectContext context)
        {
            return context.LocalStorage.Create<Coordonnee>();
        }

        public Adresse CreateAdresseSingle(Adoor.Object.Disconnected.ObjectContext context)
        {
            Adresse result = context.LocalStorage.Create<Adresse>();
            return result;
        }

        public Adresse CreateAdresse(Adoor.Object.Disconnected.ObjectContext context)
        {
            Adresse result = context.LocalStorage.Create<Adresse>();
            result.Lieu = CreateLieu(context);
            return result;
        }

        public Lieu CreateLieu(Adoor.Object.Disconnected.ObjectContext context)
        {
            Lieu result = (Lieu)context.LocalStorage.Create(typeof(Lieu));
            return result;
        }
    }

}
